//  
//  Author:
//       smdn <smdn@smdn.jp>
// 
//  Copyright (c) 2003-2014 smdn
// 
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

using System;
using System.Collections.Generic;

namespace Smdn.Applications.BittenBaum.Graphing {
  public abstract class Graph {
    public GraphType Type {
      get; private set;
    }

    public DirectoryTree DirectoryTree {
      get; private set;
    }

    protected Graph(GraphingContext context)
    {
      if (context == null)
        throw new ArgumentNullException("context");

      Type = context.Parameter.Type;
      DirectoryTree = context.Parameter.DirectoryTree;
    }

    // TODO: IReadOnlyCollection
    public abstract ICollection<IGraphElement> GetAllElements();

    // TODO: IReadOnlyCollection
    public abstract ICollection<IGraphElement> SearchElement(Predicate<IGraphElement> match);

    // TODO: IReadOnlyCollection
    public abstract ICollection<IGraphElement> SearchAllElement(Predicate<IGraphElement> match);
  }
}
